﻿<#  Current Version 1.0

    Creator: 

    Jeroen Tielen - Tielen Consultancy - www.jeroentielen.nl

    History:

    Version 1.0 = Initial Script
    
    Description: 

    This script will check the given UPD_Location for *.vhdx files and strip those file names to get the SID. 
    Then it will query the active directory to get the username which belongs to this SID.
    It will then create a text file with the same name as the vhdx file and append the username at the end. 
    If chosen to append the username at the end so the vhdx and txt file will be listed below each other (if sorted on file name). 
    Change the script as you like. (for example make an array from $UPD_Location and tweak the foreach loop a little so you can add multiple UPD locations.)

    THE SCRIPT WILL NOT DELETE VHDX FILES BUT ONLY ADD A TXT FILE.

    Howto use:

    Change the two paramters at the top and run script with user wh has rights to write at the specified location.
#>

#-------------------------------- Change This --------------------------------

$UPD_Location = "\\FILESERVER.LAB.LOCAL\MS_UPD\WS2016" # The location where the Microsoft User Profile Disks are stored and where the txt files will be created. 
$DomainName = "LAB" # Pre-Windows2000 Domain name. This part will be stripped in the file name as is also contains a "backslash"

#-------------------------------- Script --------------------------------

$Files = gci $UPD_Location -Name

Foreach ($SID in $Files) {
        If ($SID -match ".vhdx") {
            $SID = $SID.Substring(5) -replace ".vhdx"
            If ($SID-match "template") {
                Write-Host "Template File"
            } Else {
                $objSID = New-Object System.Security.Principal.SecurityIdentifier ($SID)
                $objUser = $objSID.Translate( [System.Security.Principal.NTAccount])
                $UserName = $objUSer.Value.trim("$DomainName\") 
                $TextFile = $UPD_Location + "\UVHD-" + $SID + " " + $UserName + ".txt"
                New-Item $TextFile -ItemType file -Force
            }
        }
}